﻿using System;
using System.IO;
using System.Text;

namespace Asp.Net
{
    public sealed class ScriptInjectionFilter : FilterBase
    {
        private readonly string _script;

        public ScriptInjectionFilter(Stream baseStream, Encoding encoding, string script)
            : base(baseStream, encoding)
        {
            _script = script;
        }

        protected override string FilterString(string str)
        {
            int bodyEndIndex = str.LastIndexOf("</body>", StringComparison.OrdinalIgnoreCase);
            return (bodyEndIndex >= 0) ? str.Insert(bodyEndIndex, _script) : null;
        }
    }
}