﻿using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

namespace Asp.Net.Modules
{
    public sealed class LinkResolverFilter : FilterBase
    {
        public LinkResolverFilter(Stream baseStream, Encoding encoding)
            : base(baseStream, encoding)
        {
        }

        protected override string FilterString(string str)
        {
            return LinkRE.Replace(str,
                me => string.Format(@"""{0}""", VirtualPathUtility.ToAbsolute("~/" + me.Groups["url"].Value)));
        }

        private static readonly Regex LinkRE = new Regex(@"""[~^]/(?<url>[\w\./]*)""");
    }
}