﻿using System;
using System.Web;

namespace Asp.Net.Modules
{
    public sealed class LinkResolverModule : FilterModuleBase
    {
        public override void Init(HttpApplication context)
        {
            context.ReleaseRequestState += ResolveLinks;
        }

        private void ResolveLinks(object sender, EventArgs e)
        {
            HttpApplication application = (HttpApplication)sender;
            if (application.Response.ContentType.Equals("text/html", StringComparison.OrdinalIgnoreCase))
                application.Response.Filter = new LinkResolverFilter(application.Response.Filter, application.Response.ContentEncoding);
        }
    }
}