﻿using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

namespace Asp.Net.Modules
{
    public sealed class StaticFileFilter : FilterBase
    {
        public StaticFileFilter(Stream baseStream, Encoding encoding)
            : base(baseStream, encoding)
        {
        }

        protected override string FilterString(string str)
        {
            return StaticUrlRE.Replace(str, me =>
                {
                    string relativeFileUrl = "~/" + me.Groups["file"].Value;
                    string filePath = HttpContext.Current.Server.MapPath(relativeFileUrl);
                    if (!File.Exists(filePath))
                        return VirtualPathUtility.ToAbsolute(relativeFileUrl);
                    long fileTime = File.GetLastWriteTime(filePath).Ticks;
                    return string.Format(@"Static.axd?f={0}&t={1}", me.Groups["file"].Value, fileTime);
                });
        }

        private static readonly Regex StaticUrlRE = new Regex(@"{static:(?<file>[\w\./]+)}");
    }
}
