﻿using System;
using System.Web;

namespace Asp.Net.Modules
{
    public sealed class StaticFileModule : FilterModuleBase
    {
        public override void Init(HttpApplication context)
        {
            context.ReleaseRequestState += GenerateStaticUrls;
        }

        private void GenerateStaticUrls(object sender, EventArgs e)
        {
            HttpApplication application = (HttpApplication)sender;
            if (application.Response.ContentType.StartsWith("text/", StringComparison.OrdinalIgnoreCase))
                application.Response.Filter = new StaticFileFilter(application.Response.Filter, application.Response.ContentEncoding);
        }
    }
}
